#include <arpa/inet.h>
#include <stdio.h>
#include <unistd.h>
#include "common.h"
#include "server.h"

//forward declarations
static void start_workers(server_t *self);
static void stop_workers(server_t *self);
static void destroy(server_t *self);
static void run(server_t *self);

//make an http server
//   - root_dir: the root directory of pages
server_t *make_server(char *root_dir) {
    server_t *server = malloc(sizeof(server_t));
    server->root_dir = root_dir;
    server->task_q   = make_task_queue();
    for(int i = 0; i < NR_WORKER; i++)
        server->worker[i] = make_worker(server->task_q);

    server->start_workers = start_workers;
    server->stop_workers  = stop_workers;
    server->run           = run;
    server->destroy       = destroy;

    return server;
}

//start the workers in new threads
static void start_workers(server_t *self) {
    //TODO: start all workers: worker[0 .. NR_WORKER-1]

}

//stop workers
static void stop_workers(server_t *self) {
    //TODO: stop all workers


    //add dummy tasks to wake up workers blocked on nr_task
    for(int i = 0; i < NR_WORKER; i++) {
        task_t *dummy = make_task(0, "");
        //TODO: add dummy to task_q

    }
}

//destroy self
static void destroy(server_t *self) {
    //TODO: destroy all workers


    //TODO: destroy task_q


    free(self);
}

//run the server
//   - accept connections from clients
//   - make tasks and add them to task_q
static void run(server_t *self) {
    int sfd;
    struct sockaddr_in saddr;

    //TODO: prepare sadder with SERV_PORT


    //TODO: make a server socket sft


    int enable = 1;
    ON_FALSE_EXIT(setsockopt(sfd, SOL_SOCKET, SO_REUSEADDR, &enable, sizeof(int)) >= 0, "cannot set socket option");

    //TODO: bind saddr to the server socket


    //TODO: listen to the server socket with the backlog size of 1024


#if 0
    while(1) {
#else
    //for testing purpose, handle only 10 requests
    for(int i = 0; i < 10; i++) {
#endif        
        struct sockaddr_in caddr;
        int cfd, clen = sizeof(caddr);

        //TODO: accept a connect request to the server socket


        //TODO: create a new task with cfd and root_dir

        printf("[task %3d] from client: %s:%d\n", task->id, inet_ntoa(caddr.sin_addr), caddr.sin_port);

        //TODO: add the task to task_q

    }

    //TODO: close the server socket

}
