#ifndef __SERVER__
#define __SERVER__

#include "task.h"
#include "worker.h"

#define SERV_PORT   8080
#define NR_WORKER   4

typedef struct server {
    task_queue_t *task_q;
    worker_t *worker[NR_WORKER];
    char *root_dir;

    void (*start_workers)(struct server *self);
    void (*stop_workers )(struct server *self);
    void (*run          )(struct server *self);
    void (*destroy      )(struct server *self);
} server_t;

extern server_t *make_server(char *root_dir);

#endif
