#ifndef __TASK__
#define __TASK__

#include "list.h"

typedef struct task {
    int id;             //task id
    int fd;             //client socket
    char *root_dir;     //root dir of pages
    char *method;       //we handle the GET method only
    char *url;          //the url of the requested resource
    list_t list;        //link of the next/prev task

    void (*read_request   )(struct task *self);
    void (*write_response )(struct task *self);
    void (*sample_response)(struct task *self);
    void (*destroy        )(struct task *self);
} task_t;

extern task_t *make_task(int fd, char *root_dir);

#endif
