#include <pthread.h>
#include <semaphore.h>
#include "common.h"
#include "worker.h"

//forward declarations
task_queue_t *make_task_queue();
worker_t *make_worker(task_queue_t *task_q);

static void task_queue_destroy(task_queue_t *self);
static void task_queue_add(task_queue_t *self, task_t *task);
static task_t *task_queue_remove(task_queue_t *self);
static void worker_destroy(worker_t *self);
static void worker_start(worker_t *self);
static void worker_stop(worker_t *self);
static void *worker_work(void *_self);

// task_queue
//
task_queue_t *make_task_queue() {
    task_queue_t *task_q = malloc(sizeof(task_queue_t));
    ON_FALSE_EXIT(task_q != NULL, "out of memory");

    list_init_head(&task_q->head);
    //TODO: initialize lock and nr_tasks
    //hint: lock is a binary semaphore and nr_task is a counting semaphore


    task_q->destroy = task_queue_destroy;
    task_q->add     = task_queue_add;
    task_q->remove  = task_queue_remove;
    return task_q;
}

//destroy self
static void task_queue_destroy(task_queue_t *self) {
    //TODO: destroy all tasks in the queue
    //hint: this operation requires a mutual exclusion


    //TODO: destroy lock and nr_task


    free(self);
}

//add task to self
static void task_queue_add(task_queue_t *self, task_t *task) {
    //TODO: add task to the last position of the list
    //hint: this operation requires a mutual exclusion


    //TODO: update nr_task; it may wake up a worker


}

//remove a task from self
static task_t *task_queue_remove(task_queue_t *self) {
    //TODO: update nr_task; it may block the worker


    //TODO: remove task form the first position of the list
    //hint: this operation requires a mutual exclusion


    //return the task containing plist
    return task;
}

// worker
//
worker_t *make_worker(task_queue_t *task_q) {
    static int fresh_id = 0;

    worker_t *worker = malloc(sizeof(worker_t));
    ON_FALSE_EXIT(worker != NULL, "out of memory");
    worker->id = fresh_id++;
    worker->tid = 0;
    worker->done = 0;
    worker->task_q = task_q;

    worker->destroy = worker_destroy;
    worker->start   = worker_start;
    worker->stop    = worker_stop;
    worker->work    = worker_work;
    return worker;
}

//destroy self
static void worker_destroy(worker_t *self) {
    //TODO: wait until the worker thread is terminated
    //hint: use pthread_join


    printf("[worker %d] terminated\n", self->id);
    free(self);
}

//start work in a new thread
static void worker_start(worker_t *self) {
    //TODO: set done to 0


    //TODO: run self->work in a new thread
    //hint: use pthread_create

}

//stop the work
static void worker_stop(worker_t *self) {
    //TODO: set done to 1

}

//the thread function
static void *worker_work(void *_self) {
    worker_t *self = (worker_t*)_self;
    task_t *task = NULL;
    while(1) {
        //check done before wait
        //TODO: breaK if done is true


        //TODO: remove a task from task_q


        //check done after wait
        //TODO: breaK if done is true


        printf("[worker %d] processing task %d\n", self->id, task->id);
#if 1
        //TODO: read request using task


        //TODO: write response using task


#else
        task->sample_response(task);
#endif                
        task->destroy(task);
        task = NULL;
    }
    if(task)
        task->destroy(task);
    return NULL;
}
